
#ifndef _AUTH2_
#define _AUTH2_

/* DO NOT EDIT: generated by rp2gen from /home/shafeeq/c/coda/coda-src/auth2/auth2.rpc2 */
#ifdef __cplusplus
extern "C" {
#endif __cplusplus
#include "rpc2.h"
#include "se.h"
#include "errors.h"
#ifdef __cplusplus
}
#endif __cplusplus

#ifndef _BLURB_
#define _BLURB_
/*

            Coda: an Experimental Distributed File System
                             Release 4.0

          Copyright (c) 1987-1996 Carnegie Mellon University
                         All Rights Reserved

Permission  to  use, copy, modify and distribute this software and its
documentation is hereby granted,  provided  that  both  the  copyright
notice  and  this  permission  notice  appear  in  all  copies  of the
software, derivative works or  modified  versions,  and  any  portions
thereof, and that both notices appear in supporting documentation, and
that credit is given to Carnegie Mellon University  in  all  documents
and publicity pertaining to direct or indirect use of this code or its
derivatives.

CODA IS AN EXPERIMENTAL SOFTWARE SYSTEM AND IS  KNOWN  TO  HAVE  BUGS,
SOME  OF  WHICH MAY HAVE SERIOUS CONSEQUENCES.  CARNEGIE MELLON ALLOWS
FREE USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION.   CARNEGIE  MELLON
DISCLAIMS  ANY  LIABILITY  OF  ANY  KIND  FOR  ANY  DAMAGES WHATSOEVER
RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE  OR  OF
ANY DERIVATIVE WORK.

Carnegie  Mellon  encourages  users  of  this  software  to return any
improvements or extensions that  they  make,  and  to  grant  Carnegie
Mellon the rights to redistribute these changes without encumbrance.
*/

static char *rcsid = "$Header: /afs/cs/project/coda-src/cvs/coda/coda-src/auth2/auth2.rpc2,v 4.3 1998/04/14 20:49:39 braam Exp $";
#endif /*_BLURB_*/
#define AUTH_SERVICE	"coda_auth"
#define AUTH_SUBSYSID	1993253
#define AUTH_SUCCESS	0
#define AUTH_FAILED	1
#define AUTH_DENIED	2
#define AUTH_BADKEY	3
#define AUTH_READONLY	4
#define AUTH_SETTOKENS	3
#define AUTH_GETTOKENS	9
#define AUTH_DELETETOKENS	8

typedef RPC2_Byte AuthMagic[16];
#define AUTH_MAGICVALUE	"authentication"

typedef struct SecretToken {
    AuthMagic MagicString;
    RPC2_Integer AuthHandle;
    RPC2_Integer Noise1;
    RPC2_Integer ViceId;
    RPC2_Integer BeginTimestamp;
    RPC2_Integer Noise2;
    RPC2_Integer EndTimestamp;
    RPC2_Integer Noise3;
    RPC2_EncryptionKey HandShakeKey;
    RPC2_Integer Noise4;
} SecretToken;

typedef RPC2_Byte EncryptedSecretToken[56];

typedef struct ClearToken {
    RPC2_Integer AuthHandle;
    RPC2_EncryptionKey HandShakeKey;
    RPC2_Integer ViceId;
    RPC2_Integer BeginTimestamp;
    RPC2_Integer EndTimestamp;
} ClearToken;
#define AUTHFILENAME	"auth2.pw"
#define CRUNCHPWSIZE	16

#ifdef __cplusplus
extern "C" {
#endif
extern void U_HostToNetClearToken(ClearToken *cToken);
extern void U_NetToHostClearToken(ClearToken *cToken);
extern int U_Authenticate(char *uName, char *uPasswd, ClearToken *cToken, EncryptedSecretToken sToken);
extern int U_ChangePassword(char *uName, char *newPasswd, char *myName, char *myPasswd);
extern void U_InitRPC();
extern char *U_AuthErrorMsg(int rc);
extern int U_BindToServer(char *DefAuthHost, char *uName, char *uPasswd, RPC2_Handle *RPCid);
extern char *U_Error(int rc);
extern int U_SetLocalTokens(int setPag, ClearToken *cToken, EncryptedSecretToken sToken);
extern int U_GetLocalTokens(ClearToken *cToken, EncryptedSecretToken sToken);
extern int U_DeleteLocalTokens();
#ifdef __cplusplus
}
#endif


/* The password records in the password file; never transmitted across RPC interface */
#define AUTHPWSIZE		16
struct AuthRecord
	{
	char passwd[AUTHPWSIZE];
	};



#define auth2_HEAD_VERSION	895868352

#ifndef _STUB_PREDEFINED_
#define _STUB_PREDEFINED_

typedef struct CallCountEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
} CallCountEntry;

typedef struct MultiCallEntry {
    RPC2_String name;
    RPC2_Integer countent;
    RPC2_Integer countexit;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
    RPC2_Integer counttime;
    RPC2_Integer counthost;
} MultiCallEntry;

typedef struct MultiStubWork {
    RPC2_Integer opengate;
    RPC2_Integer tsec;
    RPC2_Integer tusec;
} MultiStubWork;
#endif _STUB_PREDEFINED_

/* Op codes and definitions */

#ifdef __cplusplus
extern "C"{
#endif
long auth2_ExecuteRequest(RPC2_Handle cid, RPC2_PacketBuffer *pb, SE_Descriptor *se);

extern long S_AuthNewConn(RPC2_Handle cid, RPC2_Integer SideEffectType, RPC2_Integer SecurityLevel, RPC2_Integer EncryptionType, RPC2_CountedBS *ClientIdent);
long AuthChangePasswd(RPC2_Handle cid, RPC2_Integer viceId, RPC2_String newPasswd);
long S_AuthChangePasswd(RPC2_Handle cid, RPC2_Integer viceId, RPC2_String newPasswd);
#define AuthChangePasswd_OP	1
extern ARG AuthChangePasswd_ARGS[];
#define AuthChangePasswd_PTR	AuthChangePasswd_ARGS

long AuthGetTokens(RPC2_Handle cid, EncryptedSecretToken sToken, ClearToken *cToken);
long S_AuthGetTokens(RPC2_Handle cid, EncryptedSecretToken sToken, ClearToken *cToken);
#define AuthGetTokens_OP	2
extern ARG AuthGetTokens_ARGS[];
#define AuthGetTokens_PTR	AuthGetTokens_ARGS

long AuthChangeUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
long S_AuthChangeUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
#define AuthChangeUser_OP	3
extern ARG AuthChangeUser_ARGS[];
#define AuthChangeUser_PTR	AuthChangeUser_ARGS

long AuthNewUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
long S_AuthNewUser(RPC2_Handle cid, RPC2_Integer viceId, RPC2_EncryptionKey initKey, RPC2_String otherInfo);
#define AuthNewUser_OP	4
extern ARG AuthNewUser_ARGS[];
#define AuthNewUser_PTR	AuthNewUser_ARGS

long AuthDeleteUser(RPC2_Handle cid, RPC2_Integer viceId);
long S_AuthDeleteUser(RPC2_Handle cid, RPC2_Integer viceId);
#define AuthDeleteUser_OP	5
extern ARG AuthDeleteUser_ARGS[];
#define AuthDeleteUser_PTR	AuthDeleteUser_ARGS

long AuthNameToId(RPC2_Handle cid, RPC2_String viceName, RPC2_Integer *viceId);
long S_AuthNameToId(RPC2_Handle cid, RPC2_String viceName, RPC2_Integer *viceId);
#define AuthNameToId_OP	6
extern ARG AuthNameToId_ARGS[];
#define AuthNameToId_PTR	AuthNameToId_ARGS

long AuthQuit(RPC2_Handle cid);
long S_AuthQuit(RPC2_Handle cid);
#define AuthQuit_OP	7
extern ARG AuthQuit_ARGS[];
#define AuthQuit_PTR	AuthQuit_ARGS

#ifdef __cplusplus
}
#endif
#define auth2OPARRAYSIZE 8

extern CallCountEntry auth2_CallCount[];

extern MultiCallEntry auth2_MultiCall[];

extern MultiStubWork auth2_MultiStubWork[];

extern long auth2_ElapseSwitch;

extern long auth2_EnqueueRequest;

#endif _AUTH2_
