/* (Subsystem,Opcode) decoding stub to tcpdump */

int ADMONSUBSYSID_len = 33;
struct { int opcode; char *name; } ADMONSUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"LostConnection"},
	{2,"TokensAcquired"},
	{3,"TokensExpired"},
	{4,"ActivityPendingTokens"},
	{5,"SpaceInformation"},
	{6,"ServerAccessible"},
	{7,"ServerInaccessible"},
	{8,"ServerConnectionStrong"},
	{9,"ServerConnectionWeak"},
	{10,"NetworkQualityEstimate"},
	{11,"VolumeTransitionEvent"},
	{12,"Reconnection"},
	{13,"DataFetchEvent"},
	{14,"ReadDisconnectedCacheMissEvent"},
	{15,"WeaklyConnectedCacheMissEvent"},
	{16,"DisconnectedCacheMissEvent"},
	{17,"HoardWalkAdviceRequest"},
	{18,"HoardWalkBegin"},
	{19,"HoardWalkStatus"},
	{20,"HoardWalkEnd"},
	{21,"HoardWalkPeriodicOn"},
	{22,"HoardWalkPeriodicOff"},
	{23,"ObjectInConflict"},
	{24,"ObjectConsistent"},
	{25,"ReintegrationPendingTokens"},
	{26,"ReintegrationEnabled"},
	{27,"ReintegrationActive"},
	{28,"ReintegrationCompleted"},
	{29,"TaskAvailability"},
	{30,"TaskUnavailable"},
	{31,"ProgramAccessLogAvailable"},
	{32,"ReplacementLogAvailable"},
	{33,"InvokeASR"},
		{0,"Invalid"}
	}
;
int ADSRVSUBSYSID_len = 11;
struct { int opcode; char *name; } ADSRVSUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"NewAdviceService"},
	{2,"ConnectionAlive"},
	{3,"RegisterInterest"},
	{4,"GetServerInformation"},
	{5,"GetCacheStatistics"},
	{6,"GetNextHoardWalk"},
	{7,"OutputUsageStatistics"},
	{8,"HoardCommands"},
	{9,"SetParameters"},
	{10,"ResultOfASR"},
	{11,"ImminentDeath"},
		{0,"Invalid"}
	}
;
int AUTH_SUBSYSID_len = 7;
struct { int opcode; char *name; } AUTH_SUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"AuthChangePasswd"},
	{2,"AuthGetTokens"},
	{3,"AuthChangeUser"},
	{4,"AuthNewUser"},
	{5,"AuthDeleteUser"},
	{6,"AuthNameToId"},
	{7,"AuthQuit"},
		{0,"Invalid"}
	}
;
int SUBSYS_CB_len = 3;
struct { int opcode; char *name; } SUBSYS_CB_opcodes[] = {
	{0,"Unknown"},
	{1,"CallBack"},
	{2,"CallBackFetch"},
	{3,"CallBackReceivedStore"},
		{0,"Invalid"}
	}
;
int MondSubsysId_len = 20;
struct { int opcode; char *name; } MondSubsysId_opcodes[] = {
	{0,"Unknown"},
	{1,"MondEstablishConn"},
	{2,"VmonReportSession"},
	{3,"VmonReportCommEvent"},
	{4,"VmonReportCallEvent"},
	{5,"VmonReportMCallEvent"},
	{6,"VmonReportRVMStats"},
	{7,"VmonReportAdviceStats"},
	{8,"VmonReportMiniCache"},
	{9,"VmonReportOverflow"},
	{10,"SmonNoop"},
	{11,"SmonReportCallEvent"},
	{12,"SmonReportResEvent"},
	{13,"SmonReportOverflow"},
	{14,"SmonReportRVMResStats"},
	{15,"VmonReportIotInfo"},
	{16,"VmonReportIotStats"},
	{17,"VmonReportSubtreeStats"},
	{18,"VmonReportRepairStats"},
	{19,"VmonReportRwsStats"},
	{20,"VmonReportVCBStats"},
		{0,"Invalid"}
	}
;
int PORTMAPPER_SUBSYSID_len = 6;
struct { int opcode; char *name; } PORTMAPPER_SUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"register_excl"},
	{2,"register_sqsh"},
	{3,"delete"},
	{4,"lookup_pbynvp"},
	{5,"lookup_pbynv"},
	{6,"lookup_pbyn"},
		{0,"Invalid"}
	}
;
int RESOLUTIONSUBSYSID_len = 19;
struct { int opcode; char *name; } RESOLUTIONSUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"COP2"},
	{2,"ForceFile"},
	{3,"LockAndFetch"},
	{4,"UnlockVol"},
	{5,"MarkInc"},
	{6,"FetchFile"},
	{7,"ForceDirVV"},
	{8,"DoForceDirOps"},
	{9,"GetForceDirOps"},
	{10,"FetchLog"},
	{11,"DirResPhase2"},
	{12,"DirResPhase1"},
	{13,"DirResPhase3"},
	{14,"ResPhase2"},
	{15,"ResPhase3"},
	{16,"ResPhase34"},
	{17,"ResPhase4"},
	{18,"FetchDirContents"},
	{19,"ClearIncon"},
		{0,"Invalid"}
	}
;
int SUBSYS_SRV_len = 59;
struct { int opcode; char *name; } SUBSYS_SRV_opcodes[] = {
	{0,"Unknown"},
	{1,"ViceConnectFS"},
	{2,"ViceFetch"},
	{3,"ViceUnused1"},
	{4,"ViceRemove"},
	{5,"ViceCreate"},
	{6,"ViceRename"},
	{7,"ViceSymLink"},
	{8,"ViceLink"},
	{9,"ViceMakeDir"},
	{10,"ViceRemoveDir"},
	{11,"ViceRemoveCallBack"},
	{12,"ViceUnused2"},
	{13,"ViceUnused3"},
	{14,"ViceUnused4"},
	{15,"ViceGetRootVolume"},
	{16,"ViceSetRootVolume"},
	{17,"ViceGetVolumeStatus"},
	{18,"ViceSetVolumeStatus"},
	{19,"ViceDisconnectFS"},
	{20,"ViceGetTime"},
	{21,"ViceUnused5"},
	{22,"ViceGetStatistics"},
	{23,"ViceUnused6"},
	{24,"ViceGetVolumeInfo"},
	{25,"ViceEnableGroup"},
	{26,"ViceDisableGroup"},
	{27,"ViceProbe"},
	{28,"ViceUnused7"},
	{29,"ViceCOP2"},
	{30,"ViceResolve"},
	{31,"ViceUnused8"},
	{32,"ViceUnused9"},
	{33,"ViceRepair"},
	{34,"ViceSetVV"},
	{35,"ViceUnused10"},
	{36,"ViceUnused11"},
	{37,"ViceAllocFids"},
	{38,"ViceValidateAttrs"},
	{39,"ViceUnused12"},
	{40,"ViceNewConnectFS"},
	{41,"ViceGetVolVS"},
	{42,"ViceValidateVols"},
	{43,"ViceUnused14"},
	{44,"ViceUnused13"},
	{45,"ViceVRemove"},
	{46,"ViceVCreate"},
	{47,"ViceVRename"},
	{48,"ViceVSymLink"},
	{49,"ViceVLink"},
	{50,"ViceVMakeDir"},
	{51,"ViceVRemoveDir"},
	{52,"ViceNewStore"},
	{53,"ViceNewVStore"},
	{54,"ViceVIncReintegrate"},
	{55,"ViceOpenReintHandle"},
	{56,"ViceQueryReintHandle"},
	{57,"ViceSendReintFragment"},
	{58,"ViceCloseReintHandle"},
	{59,"ViceReintegrate"},
		{0,"Invalid"}
	}
;
int VOLDUMP_SUBSYSTEMID_len = 2;
struct { int opcode; char *name; } VOLDUMP_SUBSYSTEMID_opcodes[] = {
	{0,"Unknown"},
	{1,"WriteDump"},
	{2,"ReadDump"},
		{0,"Invalid"}
	}
;
int UTIL_SUBSYSID_len = 38;
struct { int opcode; char *name; } UTIL_SUBSYSID_opcodes[] = {
	{0,"Unknown"},
	{1,"VolSalvage"},
	{2,"VolCreate"},
	{3,"VolInfo"},
	{4,"VolMakeVLDB"},
	{5,"VolMakeVRDB"},
	{6,"VolShowVnode"},
	{7,"VolSetVV"},
	{8,"VolPurge"},
	{9,"VolLookup"},
	{10,"VolUpdateDB"},
	{11,"VolShutdown"},
	{12,"VolSwaplog"},
	{13,"VolSetDebug"},
	{14,"VolDump"},
	{15,"VolNewDump"},
	{16,"VolClone"},
	{17,"VolRestore"},
	{18,"VolMerge"},
	{19,"VolMakeBackups"},
	{20,"VolMarkAsAncient"},
	{21,"VolDumpMem"},
	{22,"VolLock"},
	{23,"VolUnlock"},
	{24,"VolRVMSize"},
	{25,"VolSetLogParms"},
	{26,"VolTiming"},
	{27,"VolElapse"},
	{28,"PrintStats"},
	{29,"TraceRpc"},
	{30,"ShowCallbacks"},
	{31,"TruncateRVMLog"},
	{32,"VolGetMaxVolId"},
	{33,"VolSetMaxVolId"},
	{34,"VolPeekInt"},
	{35,"VolPokeInt"},
	{36,"VolPeekMem"},
	{37,"VolPokeMem"},
	{38,"VolSwapmalloc"},
		{0,"Invalid"}
	}
;
int print_rpc2_opcodes(int subsys, int opcode) {

	if (subsys == 100) {
		if ((opcode > 0) && (opcode <= ADMONSUBSYSID_len)) 
			printf(" ss:ADMONSUBSYSID oc:%s",ADMONSUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:ADMONSUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 300) {
		if ((opcode > 0) && (opcode <= ADSRVSUBSYSID_len)) 
			printf(" ss:ADSRVSUBSYSID oc:%s",ADSRVSUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:ADSRVSUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 1993253) {
		if ((opcode > 0) && (opcode <= AUTH_SUBSYSID_len)) 
			printf(" ss:AUTH_SUBSYSID oc:%s",AUTH_SUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:AUTH_SUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 127823) {
		if ((opcode > 0) && (opcode <= SUBSYS_CB_len)) 
			printf(" ss:SUBSYS_CB oc:%s",SUBSYS_CB_opcodes[opcode].name);
		else
			printf(" ss:SUBSYS_CB oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 171717) {
		if ((opcode > 0) && (opcode <= MondSubsysId_len)) 
			printf(" ss:MondSubsysId oc:%s",MondSubsysId_opcodes[opcode].name);
		else
			printf(" ss:MondSubsysId oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 1) {
		if ((opcode > 0) && (opcode <= PORTMAPPER_SUBSYSID_len)) 
			printf(" ss:PORTMAPPER_SUBSYSID oc:%s",PORTMAPPER_SUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:PORTMAPPER_SUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 5893) {
		if ((opcode > 0) && (opcode <= RESOLUTIONSUBSYSID_len)) 
			printf(" ss:RESOLUTIONSUBSYSID oc:%s",RESOLUTIONSUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:RESOLUTIONSUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 1001) {
		if ((opcode > 0) && (opcode <= SUBSYS_SRV_len)) 
			printf(" ss:SUBSYS_SRV oc:%s",SUBSYS_SRV_opcodes[opcode].name);
		else
			printf(" ss:SUBSYS_SRV oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 123) {
		if ((opcode > 0) && (opcode <= VOLDUMP_SUBSYSTEMID_len)) 
			printf(" ss:VOLDUMP_SUBSYSTEMID oc:%s",VOLDUMP_SUBSYSTEMID_opcodes[opcode].name);
		else
			printf(" ss:VOLDUMP_SUBSYSTEMID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

	if (subsys == 7777) {
		if ((opcode > 0) && (opcode <= UTIL_SUBSYSID_len)) 
			printf(" ss:UTIL_SUBSYSID oc:%s",UTIL_SUBSYSID_opcodes[opcode].name);
		else
			printf(" ss:UTIL_SUBSYSID oc:%s",rpc2_printoc(0,opcode));
		return 1;
	}

return 0;
}
